import{S as at,i as et,s as tt,e as s,k as c,w as U,t as o,M as st,c as r,d as e,m as f,a as l,x as R,h as n,b as h,G as t,g as p,y as V,q as z,o as B,B as J,v as rt}from"../chunks/vendor-hf-doc-builder.js";import{T as ot}from"../chunks/Tip-hf-doc-builder.js";import{I as Ha}from"../chunks/IconCopyLink-hf-doc-builder.js";import{C as Ze}from"../chunks/CodeBlock-hf-doc-builder.js";function nt(ka){let m,b,u,g,$;return{c(){m=s("p"),b=o("In a different session, a Spark DataFrame doesn\u2019t have the same "),u=s("a"),g=o("semantic hash"),$=o(", and it will rerun a Spark job and store it in a new cache."),this.h()},l(d){m=r(d,"P",{});var k=l(m);b=n(k,"In a different session, a Spark DataFrame doesn\u2019t have the same "),u=r(k,"A",{href:!0,rel:!0});var A=l(u);g=n(A,"semantic hash"),A.forEach(e),$=n(k,", and it will rerun a Spark job and store it in a new cache."),k.forEach(e),this.h()},h(){h(u,"href","https://spark.apache.org/docs/3.2.0/api/python/reference/api/pyspark.sql.DataFrame.semanticHash.html"),h(u,"rel","nofollow")},m(d,k){p(d,m,k),t(m,b),t(m,u),t(u,g),t(m,$)},d(d){d&&e(m)}}}function lt(ka){let m,b,u,g,$,d,k,A,Ua,va,F,Ra,G,Va,za,_a,X,Ba,wa,D,S,oa,N,Ja,na,Ga,ya,q,Xa,K,Ka,Qa,$a,v,Wa,Q,Za,ae,la,ee,te,Da,M,ja,P,se,W,re,oe,Ea,j,x,ia,O,ne,pa,le,ba,_,ie,Z,pe,he,ha,ce,fe,Aa,w,me,ca,ue,de,fa,ge,ke,Fa,T,Sa,E,C,ma,L,ve,ua,_e,qa,y,we,da,ye,$e,ga,De,je,Pa,Y,xa,I,Ee,aa,be,Ae,Ta;return d=new Ha({}),N=new Ha({}),M=new Ze({props:{code:`from datasets import Dataset
df = spark.createDataFrame(
    data=[[1, "Elia"], [2, "Teo"], [3, "Fang"]],
    columns=["id", "name"],
)
ds = Dataset.from_spark(df)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset
<span class="hljs-meta">&gt;&gt;&gt; </span>df = spark.createDataFrame(
<span class="hljs-meta">... </span>    data=[[<span class="hljs-number">1</span>, <span class="hljs-string">&quot;Elia&quot;</span>], [<span class="hljs-number">2</span>, <span class="hljs-string">&quot;Teo&quot;</span>], [<span class="hljs-number">3</span>, <span class="hljs-string">&quot;Fang&quot;</span>]],
<span class="hljs-meta">... </span>    columns=[<span class="hljs-string">&quot;id&quot;</span>, <span class="hljs-string">&quot;name&quot;</span>],
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>ds = Dataset.from_spark(df)`}}),O=new Ha({}),T=new ot({props:{warning:!0,$$slots:{default:[nt]},$$scope:{ctx:ka}}}),L=new Ha({}),Y=new Ze({props:{code:`from datasets import Dataset, Features, Image, Value
data = [(0, open("image.png", "rb").read())]
df = spark.createDataFrame(data, "idx: int, image: binary")
# Also works if you have arrays
# data = [(0, np.zeros(shape=(32, 32, 3), dtype=np.int32).tolist())]
# df = spark.createDataFrame(data, "idx: int, image: array<array<array<int>>>")
features = Features({"idx": Value("int64"), "image": Image()})
dataset = Dataset.from_spark(df, features=features)
dataset[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> datasets <span class="hljs-keyword">import</span> Dataset, Features, Image, Value
<span class="hljs-meta">&gt;&gt;&gt; </span>data = [(<span class="hljs-number">0</span>, <span class="hljs-built_in">open</span>(<span class="hljs-string">&quot;image.png&quot;</span>, <span class="hljs-string">&quot;rb&quot;</span>).read())]
<span class="hljs-meta">&gt;&gt;&gt; </span>df = spark.createDataFrame(data, <span class="hljs-string">&quot;idx: int, image: binary&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Also works if you have arrays</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># data = [(0, np.zeros(shape=(32, 32, 3), dtype=np.int32).tolist())]</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># df = spark.createDataFrame(data, &quot;idx: int, image: array&lt;array&lt;array&lt;int&gt;&gt;&gt;&quot;)</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>features = Features({<span class="hljs-string">&quot;idx&quot;</span>: Value(<span class="hljs-string">&quot;int64&quot;</span>), <span class="hljs-string">&quot;image&quot;</span>: Image()})
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset = Dataset.from_spark(df, features=features)
<span class="hljs-meta">&gt;&gt;&gt; </span>dataset[<span class="hljs-number">0</span>]
{<span class="hljs-string">&#x27;idx&#x27;</span>: <span class="hljs-number">0</span>, <span class="hljs-string">&#x27;image&#x27;</span>: &lt;PIL.PngImagePlugin.PngImageFile image mode=RGB size=32x32&gt;}`}}),{c(){m=s("meta"),b=c(),u=s("h1"),g=s("a"),$=s("span"),U(d.$$.fragment),k=c(),A=s("span"),Ua=o("Use with Spark"),va=c(),F=s("p"),Ra=o("This document is a quick introduction to using \u{1F917} Datasets with Spark, with a particular focus on how to load a Spark DataFrame into a "),G=s("a"),Va=o("Dataset"),za=o(" object."),_a=c(),X=s("p"),Ba=o("From there, you have fast access to any element and you can use it as a data loader to train models."),wa=c(),D=s("h2"),S=s("a"),oa=s("span"),U(N.$$.fragment),Ja=c(),na=s("span"),Ga=o("Load from Spark"),ya=c(),q=s("p"),Xa=o("A "),K=s("a"),Ka=o("Dataset"),Qa=o(` object is a wrapper of an Arrow table, which allows fast reads from arrays in the dataset to PyTorch, TensorFlow and JAX tensors.
The Arrow table is memory mapped from disk, which can load datasets bigger than your available RAM.`),$a=c(),v=s("p"),Wa=o("You can get a "),Q=s("a"),Za=o("Dataset"),ae=o(" from a Spark DataFrame using "),la=s("code"),ee=o("Dataset.from_spark()"),te=o(":"),Da=c(),U(M.$$.fragment),ja=c(),P=s("p"),se=o("The Spark workers write the dataset on disk in a cache directory as Arrow files, and the "),W=s("a"),re=o("Dataset"),oe=o(" is loaded from there."),Ea=c(),j=s("h3"),x=s("a"),ia=s("span"),U(O.$$.fragment),ne=c(),pa=s("span"),le=o("Caching"),ba=c(),_=s("p"),ie=o("The resulting "),Z=s("a"),pe=o("Dataset"),he=o(" is cached; if you call "),ha=s("code"),ce=o("Dataset.from_spark()"),fe=o(` multiple times on the same DataFrame it won\u2019t re-run the Spark
job that writes the dataset as Arrow files on disk.`),Aa=c(),w=s("p"),me=o("You can set the cache location by passing "),ca=s("code"),ue=o("cache_dir="),de=o(" to "),fa=s("code"),ge=o("Dataset.from_spark()"),ke=o(`.
Make sure to use a disk that is available to both your workers and your current machine (the driver).`),Fa=c(),U(T.$$.fragment),Sa=c(),E=s("h3"),C=s("a"),ma=s("span"),U(L.$$.fragment),ve=c(),ua=s("span"),_e=o("Feature types"),qa=c(),y=s("p"),we=o("If your dataset is made of images, audio data or N-dimensional arrays, you can specify the "),da=s("code"),ye=o("features="),$e=o(" argument in "),ga=s("code"),De=o("Dataset.from_spark()"),je=o(":"),Pa=c(),U(Y.$$.fragment),xa=c(),I=s("p"),Ee=o("You can check the "),aa=s("a"),be=o("Features"),Ae=o(" documentation to know about all the feature types available."),this.h()},l(a){const i=st('[data-svelte="svelte-1phssyn"]',document.head);m=r(i,"META",{name:!0,content:!0}),i.forEach(e),b=f(a),u=r(a,"H1",{class:!0});var H=l(u);g=r(H,"A",{id:!0,class:!0,href:!0});var Fe=l(g);$=r(Fe,"SPAN",{});var Se=l($);R(d.$$.fragment,Se),Se.forEach(e),Fe.forEach(e),k=f(H),A=r(H,"SPAN",{});var qe=l(A);Ua=n(qe,"Use with Spark"),qe.forEach(e),H.forEach(e),va=f(a),F=r(a,"P",{});var Ca=l(F);Ra=n(Ca,"This document is a quick introduction to using \u{1F917} Datasets with Spark, with a particular focus on how to load a Spark DataFrame into a "),G=r(Ca,"A",{href:!0});var Pe=l(G);Va=n(Pe,"Dataset"),Pe.forEach(e),za=n(Ca," object."),Ca.forEach(e),_a=f(a),X=r(a,"P",{});var xe=l(X);Ba=n(xe,"From there, you have fast access to any element and you can use it as a data loader to train models."),xe.forEach(e),wa=f(a),D=r(a,"H2",{class:!0});var Ia=l(D);S=r(Ia,"A",{id:!0,class:!0,href:!0});var Te=l(S);oa=r(Te,"SPAN",{});var Ce=l(oa);R(N.$$.fragment,Ce),Ce.forEach(e),Te.forEach(e),Ja=f(Ia),na=r(Ia,"SPAN",{});var Ie=l(na);Ga=n(Ie,"Load from Spark"),Ie.forEach(e),Ia.forEach(e),ya=f(a),q=r(a,"P",{});var Na=l(q);Xa=n(Na,"A "),K=r(Na,"A",{href:!0});var Ne=l(K);Ka=n(Ne,"Dataset"),Ne.forEach(e),Qa=n(Na,` object is a wrapper of an Arrow table, which allows fast reads from arrays in the dataset to PyTorch, TensorFlow and JAX tensors.
The Arrow table is memory mapped from disk, which can load datasets bigger than your available RAM.`),Na.forEach(e),$a=f(a),v=r(a,"P",{});var ea=l(v);Wa=n(ea,"You can get a "),Q=r(ea,"A",{href:!0});var Me=l(Q);Za=n(Me,"Dataset"),Me.forEach(e),ae=n(ea," from a Spark DataFrame using "),la=r(ea,"CODE",{});var Oe=l(la);ee=n(Oe,"Dataset.from_spark()"),Oe.forEach(e),te=n(ea,":"),ea.forEach(e),Da=f(a),R(M.$$.fragment,a),ja=f(a),P=r(a,"P",{});var Ma=l(P);se=n(Ma,"The Spark workers write the dataset on disk in a cache directory as Arrow files, and the "),W=r(Ma,"A",{href:!0});var Le=l(W);re=n(Le,"Dataset"),Le.forEach(e),oe=n(Ma," is loaded from there."),Ma.forEach(e),Ea=f(a),j=r(a,"H3",{class:!0});var Oa=l(j);x=r(Oa,"A",{id:!0,class:!0,href:!0});var Ye=l(x);ia=r(Ye,"SPAN",{});var He=l(ia);R(O.$$.fragment,He),He.forEach(e),Ye.forEach(e),ne=f(Oa),pa=r(Oa,"SPAN",{});var Ue=l(pa);le=n(Ue,"Caching"),Ue.forEach(e),Oa.forEach(e),ba=f(a),_=r(a,"P",{});var ta=l(_);ie=n(ta,"The resulting "),Z=r(ta,"A",{href:!0});var Re=l(Z);pe=n(Re,"Dataset"),Re.forEach(e),he=n(ta," is cached; if you call "),ha=r(ta,"CODE",{});var Ve=l(ha);ce=n(Ve,"Dataset.from_spark()"),Ve.forEach(e),fe=n(ta,` multiple times on the same DataFrame it won\u2019t re-run the Spark
job that writes the dataset as Arrow files on disk.`),ta.forEach(e),Aa=f(a),w=r(a,"P",{});var sa=l(w);me=n(sa,"You can set the cache location by passing "),ca=r(sa,"CODE",{});var ze=l(ca);ue=n(ze,"cache_dir="),ze.forEach(e),de=n(sa," to "),fa=r(sa,"CODE",{});var Be=l(fa);ge=n(Be,"Dataset.from_spark()"),Be.forEach(e),ke=n(sa,`.
Make sure to use a disk that is available to both your workers and your current machine (the driver).`),sa.forEach(e),Fa=f(a),R(T.$$.fragment,a),Sa=f(a),E=r(a,"H3",{class:!0});var La=l(E);C=r(La,"A",{id:!0,class:!0,href:!0});var Je=l(C);ma=r(Je,"SPAN",{});var Ge=l(ma);R(L.$$.fragment,Ge),Ge.forEach(e),Je.forEach(e),ve=f(La),ua=r(La,"SPAN",{});var Xe=l(ua);_e=n(Xe,"Feature types"),Xe.forEach(e),La.forEach(e),qa=f(a),y=r(a,"P",{});var ra=l(y);we=n(ra,"If your dataset is made of images, audio data or N-dimensional arrays, you can specify the "),da=r(ra,"CODE",{});var Ke=l(da);ye=n(Ke,"features="),Ke.forEach(e),$e=n(ra," argument in "),ga=r(ra,"CODE",{});var Qe=l(ga);De=n(Qe,"Dataset.from_spark()"),Qe.forEach(e),je=n(ra,":"),ra.forEach(e),Pa=f(a),R(Y.$$.fragment,a),xa=f(a),I=r(a,"P",{});var Ya=l(I);Ee=n(Ya,"You can check the "),aa=r(Ya,"A",{href:!0});var We=l(aa);be=n(We,"Features"),We.forEach(e),Ae=n(Ya," documentation to know about all the feature types available."),Ya.forEach(e),this.h()},h(){h(m,"name","hf:doc:metadata"),h(m,"content",JSON.stringify(it)),h(g,"id","use-with-spark"),h(g,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(g,"href","#use-with-spark"),h(u,"class","relative group"),h(G,"href","/docs/datasets/v2.12.0/en/package_reference/main_classes#datasets.Dataset"),h(S,"id","load-from-spark"),h(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(S,"href","#load-from-spark"),h(D,"class","relative group"),h(K,"href","/docs/datasets/v2.12.0/en/package_reference/main_classes#datasets.Dataset"),h(Q,"href","/docs/datasets/v2.12.0/en/package_reference/main_classes#datasets.Dataset"),h(W,"href","/docs/datasets/v2.12.0/en/package_reference/main_classes#datasets.Dataset"),h(x,"id","caching"),h(x,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(x,"href","#caching"),h(j,"class","relative group"),h(Z,"href","/docs/datasets/v2.12.0/en/package_reference/main_classes#datasets.Dataset"),h(C,"id","feature-types"),h(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),h(C,"href","#feature-types"),h(E,"class","relative group"),h(aa,"href","/docs/datasets/v2.12.0/en/package_reference/main_classes#datasets.Features")},m(a,i){t(document.head,m),p(a,b,i),p(a,u,i),t(u,g),t(g,$),V(d,$,null),t(u,k),t(u,A),t(A,Ua),p(a,va,i),p(a,F,i),t(F,Ra),t(F,G),t(G,Va),t(F,za),p(a,_a,i),p(a,X,i),t(X,Ba),p(a,wa,i),p(a,D,i),t(D,S),t(S,oa),V(N,oa,null),t(D,Ja),t(D,na),t(na,Ga),p(a,ya,i),p(a,q,i),t(q,Xa),t(q,K),t(K,Ka),t(q,Qa),p(a,$a,i),p(a,v,i),t(v,Wa),t(v,Q),t(Q,Za),t(v,ae),t(v,la),t(la,ee),t(v,te),p(a,Da,i),V(M,a,i),p(a,ja,i),p(a,P,i),t(P,se),t(P,W),t(W,re),t(P,oe),p(a,Ea,i),p(a,j,i),t(j,x),t(x,ia),V(O,ia,null),t(j,ne),t(j,pa),t(pa,le),p(a,ba,i),p(a,_,i),t(_,ie),t(_,Z),t(Z,pe),t(_,he),t(_,ha),t(ha,ce),t(_,fe),p(a,Aa,i),p(a,w,i),t(w,me),t(w,ca),t(ca,ue),t(w,de),t(w,fa),t(fa,ge),t(w,ke),p(a,Fa,i),V(T,a,i),p(a,Sa,i),p(a,E,i),t(E,C),t(C,ma),V(L,ma,null),t(E,ve),t(E,ua),t(ua,_e),p(a,qa,i),p(a,y,i),t(y,we),t(y,da),t(da,ye),t(y,$e),t(y,ga),t(ga,De),t(y,je),p(a,Pa,i),V(Y,a,i),p(a,xa,i),p(a,I,i),t(I,Ee),t(I,aa),t(aa,be),t(I,Ae),Ta=!0},p(a,[i]){const H={};i&2&&(H.$$scope={dirty:i,ctx:a}),T.$set(H)},i(a){Ta||(z(d.$$.fragment,a),z(N.$$.fragment,a),z(M.$$.fragment,a),z(O.$$.fragment,a),z(T.$$.fragment,a),z(L.$$.fragment,a),z(Y.$$.fragment,a),Ta=!0)},o(a){B(d.$$.fragment,a),B(N.$$.fragment,a),B(M.$$.fragment,a),B(O.$$.fragment,a),B(T.$$.fragment,a),B(L.$$.fragment,a),B(Y.$$.fragment,a),Ta=!1},d(a){e(m),a&&e(b),a&&e(u),J(d),a&&e(va),a&&e(F),a&&e(_a),a&&e(X),a&&e(wa),a&&e(D),J(N),a&&e(ya),a&&e(q),a&&e($a),a&&e(v),a&&e(Da),J(M,a),a&&e(ja),a&&e(P),a&&e(Ea),a&&e(j),J(O),a&&e(ba),a&&e(_),a&&e(Aa),a&&e(w),a&&e(Fa),J(T,a),a&&e(Sa),a&&e(E),J(L),a&&e(qa),a&&e(y),a&&e(Pa),J(Y,a),a&&e(xa),a&&e(I)}}}const it={local:"use-with-spark",sections:[{local:"load-from-spark",sections:[{local:"caching",title:"Caching"},{local:"feature-types",title:"Feature types"}],title:"Load from Spark"}],title:"Use with Spark"};function pt(ka){return rt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ut extends at{constructor(m){super();et(this,m,pt,lt,tt,{})}}export{ut as default,it as metadata};
